<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>Task29.60</title>
</head>

<body onload="onLoadingPaging()">
    <div class="container jumbotron">
        <h1 class="text-center">Danh sách người dùng đăng ký</h1>
        <table id="user-table" class="table table-bordered table-striped table-hover">
            <thead>
                <tr>
                    <th>Mã người dùng</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Actions</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>


    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL = "http://203.171.20.210:8080/devcamp-register-java-api/users";
        const gEND_OF_ROW_COL = -1;
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onLoadingPaging() {
            "use strict";
            //gọi server
            var vXHTMLRequest = new XMLHttpRequest();
            vXHTMLRequest.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    //xử lý hiển thị
                    showDataOnTable(vXHTMLRequest);
                    // gán sự kiện click cho nút chi tiết
                    addListonerEventInfoButton();
                }
            };
            callApiGetUsers(vXHTMLRequest);
        }
        /*** REGION 4 - Common functions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        function callApiGetUsers(paramXmlHttp) {
            "use strict";
            paramXmlHttp.open("GET", gBASE_URL, true);
            paramXmlHttp.send();
        }
        function showDataOnTable(paramXmlHttpUser) {
            "use strict";
            console.log(paramXmlHttpUser.responseText);
            // chuyển json sang object
            var vResponse = JSON.parse(paramXmlHttpUser.responseText);
            var vTable = document.getElementById("user-table");
            var vTableBody = vTable.getElementsByTagName("tbody")[0];
            for (var bI = 0; bI < vResponse.length; bI++) {
                // tạo dòng mới cho bảng và ghi vào các giá trị 
                var vNewRow = vTableBody.insertRow(gEND_OF_ROW_COL);
                var vCellMaNguoiDung = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellFirstName = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellLastName = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellCountry = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellSubject = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellCustomerType = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellRegisterStatus = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellUserAction = vNewRow.insertCell(gEND_OF_ROW_COL);

                vCellMaNguoiDung.innerHTML = vResponse[bI].id;
                vCellFirstName.innerHTML = vResponse[bI].firstname;
                vCellLastName.innerHTML = vResponse[bI].lastname;
                vCellCountry.innerHTML = vResponse[bI].country;
                vCellSubject.innerHTML = vResponse[bI].subject;
                vCellCustomerType.innerHTML = vResponse[bI].customerType;
                vCellRegisterStatus.innerHTML = vResponse[bI].registerStatus;

                // button, chứa data của dòng
                var vDetailButton = document.createElement("button");
                vDetailButton.className = "info-user btn btn-info";
                vDetailButton.setAttribute("data-id", vResponse[bI].id);
                vDetailButton.setAttribute("data-firstname", vResponse[bI].firstname);
                vDetailButton.setAttribute("data-lastname", vResponse[bI].lastname);
                vDetailButton.setAttribute("data-country", vResponse[bI].country);
                vDetailButton.setAttribute("data-subject", vResponse[bI].subject);
                vDetailButton.setAttribute("data-customer-type", vResponse[bI].customerType);
                vDetailButton.setAttribute("data-register-status", vResponse[bI].registerStatus);
                vDetailButton.innerHTML = "Chi tiết";
                vCellUserAction.appendChild(vDetailButton);
            }
        }
        // add listener cho event handler 
        // khi nhấn nút sẽ gọi hàm onBtnChiTiet
        function addListonerEventInfoButton() {
            // truy xuất tất cả các nút detail qua className
            var vDetailButtons = document.getElementsByClassName("info-user");
            for (var bI = 0; bI < vDetailButtons.length; bI++) {
                vDetailButtons[bI].addEventListener('click', function () {
                    onBtnChiTietClick(this);
                });
            }
        }
        // onBtnChiTietClick
        function onBtnChiTietClick(paramDetailButton) {
            // thu thập dữ liệu
            var vUserId = paramDetailButton.dataset.id;
            var vFirstName = paramDetailButton.dataset.firstname;
            var vLastName = paramDetailButton.dataset.lastname;
            var vCountry = paramDetailButton.dataset.country;
            var vSubject = paramDetailButton.dataset.subject;
            var vCustomerType = paramDetailButton.dataset.customerType;
            var vRegisterStatus = paramDetailButton.dataset.registerStatus;
            console.log("Thông tin user");
            console.log("User id: ", vUserId);
            console.log("First name: ", vFirstName);
            console.log("Last name: ", vLastName);
            console.log("Country: ", vCountry);
            console.log("Subject: ", vSubject);
            console.log("Customer Type: ", vCustomerType);
            console.log("Register Status: ", vRegisterStatus);
            const vDETAIL_FORM_URL = "task29.70+80.html";
            var vUrlSiteToOpen = vDETAIL_FORM_URL + "?" +
                "id=" + vUserId;
            window.location.href = vUrlSiteToOpen;
        }
    </script>

</body>

</html>